xquery version "1.0";

declare namespace exist = "http://exist.sourceforge.net/NS/exist";
import module namespace request = "http://exist-db.org/xquery/request";
import module namespace response = "http://exist-db.org/xquery/response";

import module namespace wheel = "http://wheelfactory.com" at "wheel.xqm";

declare variable $exist:path external;

if(matches($exist:path, "/factory/warehouse/wheel/[0-9A-Za-z\\-]+"))then
    
    let $wheel-id :=
        replace($exist:path, "/factory/warehouse/wheel/([0-9A-Za-z\\-]+)", "$1")
        return
    
        if(request:get-method() eq "GET")then
            let $wheel := wheel:retrieve-wheel($wheel-id) return
                if(empty($wheel))then
                    (response:set-status-code(404),
                        <error>wheel not found {$wheel-id}</error>)
                else
                    $wheel
        
        else if(request:get-method() eq "PUT")then
            if(wheel:store-wheel($wheel-id, request:get-data()))then
                (response:set-status-code(201),
                    response:set-header("Location", concat("/factory/warehouse/wheel/", $wheel-id)))
            else
                (response:set-status-code(500),
                    <error>Could not store wheel. Warehouse is full?</error>)
        else
            (response:set-status-code(405),
                <error>Unknown Method</error>)
        
else if(matches($exist:path, "/factory/warehouse/wheel"))then
    
    if(request:get-method() eq "GET")then
        wheel:inventory()
    
    else if(request:get-method eq "POST") then
        let $wheel-id := wheel:create-wheel(request:get-data()) return
            if(not(empty($wheel-id)))then
                (response:set-status-code(201),
                    response:set-header("Location", concat("/factory/warehouse/wheel/", $wheel-id)))
            else
                (response:set-status-code(500),
                    <error>Could not create wheel. Factory has broken down?</error>)
    else
       (response:set-status-code(405),
            <error>Unknown Method</error>)

else
       (response:set-status-code(400),
            <error>Bad Request</error>)